import java.util.*;
import java.util.Map.Entry;

public class ContainerShortestPathSearchResults 
{
	/**
	 * in each permutation, each internal has the information such as row and column permutations
	 * minimum sums of squares 
	 */
	TreeMap<String, ArrayList<Integer>> permutationIndices = null;
	TreeMap<String, Double> minimumAtInternals = null;
	TreeMap<String, double[][]> bestFitNonStationaryJointProbMatrices = null;
	TreeMap<String, double[]> bestFitNonStationaryMarginalFrequencies = null;
	TreeMap<String, double[][]> bestFitBHJoints = null;
	TreeMap<String, Node> reconstructedTree = null;
	TreeMap<String, double[][]> bestFitCondsMatrices = null;
	
	double minimumSumOfSquares = 0.0;
	int    itrCounter = 0;
	
	public ContainerShortestPathSearchResults() 
	{
		permutationIndices = new TreeMap<String, ArrayList<Integer>>();
		minimumAtInternals = new TreeMap<String, Double>();
		bestFitNonStationaryJointProbMatrices = new TreeMap<String, double[][]>();
		bestFitNonStationaryMarginalFrequencies = new TreeMap<String, double[]>();
		bestFitBHJoints = new TreeMap<String, double[][]>();
		reconstructedTree = new TreeMap<String, Node>();
		bestFitCondsMatrices = new TreeMap<String, double[][]>();
	}
	
	void setItrCounter(int inputValue)
	{
		itrCounter = inputValue;
	}
	
	void setMinimumSumOfSquares(double inputValue)
	{
		minimumSumOfSquares = inputValue;
	}
	
	void setMinimumAtInternals(TreeMap<String, Double> inputCon)
	{
		minimumAtInternals.putAll(inputCon);
	}
	
	void setPermutationIndices(TreeMap<String, ArrayList<Integer>> inputCon)
	{
		permutationIndices.putAll(inputCon);
	}
	
	void setBestFitNonStationaryJointProbMatricesAll(TreeMap<String, double[][]> inputCon)
	{
		bestFitNonStationaryJointProbMatrices.putAll(inputCon);
	}
	
	void setBestFitNonStationaryJointProbMatrices(String inputKey, double[][] inputCon)
	{
		bestFitNonStationaryJointProbMatrices.put(inputKey, inputCon);
	}

	void setBestFitNonStationaryMarginalFrequenciesAll(TreeMap<String, double[]> inputCon)
	{
		bestFitNonStationaryMarginalFrequencies.putAll(inputCon);
	}
	
	void setBestFitNonStationaryMarginalFrequencies(String inputKey, double[] inputCon)
	{
		bestFitNonStationaryMarginalFrequencies.put(inputKey, inputCon);
	}

	void setBestFitBH(String inputKey, double[][] inputCon)
	{
		bestFitBHJoints.put(inputKey, inputCon);
	}

	void setBestFitBH(TreeMap<String, double[][]> inputCon)
	{
		bestFitBHJoints.putAll(inputCon);
	}
	
	int getItrCounter()
	{
		return itrCounter;
	}
	
	double getMinimumSumOfSquares()
	{
		return minimumSumOfSquares;
	}
	
	TreeMap<String, Double> getMinimumAtInternals()
	{
		return minimumAtInternals;
	}
	
	TreeMap<String, ArrayList<Integer>> getPermutationIndices()
	{
		return permutationIndices;
	}
	
	TreeMap<String, double[][]> getBestFitNonStationaryJointProbMatrices()
	{
		return bestFitNonStationaryJointProbMatrices;
	}
	
	TreeMap<String, double[]> getBestFitNonStationaryMarginalFrequencies()
	{
		return bestFitNonStationaryMarginalFrequencies;
	}
	
	TreeMap<String, double[][]> getBestFitBHJoints()
	{
		return bestFitBHJoints;
	}
	
	TreeMap<String, Node> getRecontructedTree()
	{
		return reconstructedTree;
	}
	
	void setReconstructedTree(TreeMap<String, Node> inputCon)
	{
		reconstructedTree.putAll(inputCon);
	}
	
	void setBestFitNonStationaryConds(TreeMap<String, double[][]> inputBestFitNonStationaryConds)
	{
		bestFitCondsMatrices.putAll(inputBestFitNonStationaryConds);
	}
	
	TreeMap<String, double[][]> getBestFitNonStationaryConds()
	{
		return bestFitCondsMatrices;
	}
	
	public String toString()
	{
		String result = "";
		Set<Map.Entry<String, Double>> aSetOfMinis = minimumAtInternals.entrySet();
		Set<Map.Entry<String, ArrayList<Integer>>> aSetOfPermutations = permutationIndices.entrySet();
		Set<Map.Entry<String, double[][]>> aSetOfBestFitJointProbMatrices = bestFitNonStationaryJointProbMatrices.entrySet();
		Set<Map.Entry<String, double[]>> aSetOfBestFitMarginalFrequencies = bestFitNonStationaryMarginalFrequencies.entrySet();
		
		Iterator<Entry<String, Double>> minItr = aSetOfMinis.iterator();
		Iterator<Entry<String, ArrayList<Integer>>> permutationItr = aSetOfPermutations.iterator();
		Iterator<Entry<String, double[][]>> bestFitJointProbMatricesItr = aSetOfBestFitJointProbMatrices.iterator();
		Iterator<Entry<String, double[]>> bestFitMarginalFrequenciesItr = aSetOfBestFitMarginalFrequencies.iterator();
		
		Map.Entry<String, Double> tmpMini;
		Map.Entry<String, ArrayList<Integer>> tmpPermutation;
		Map.Entry<String, double[][]> tmpBestFitJointProbMatrices;
		Map.Entry<String, double[]> tmpBestFitFrequencies;
		
		ArrayList<Integer> tmpList;
		
		double[][] tmpJointMatrix;
		double[] tmpMarginalVector;
		
		String tmpNodeName; 
		
		int j, k;
		
		result += "Total iterations: " + itrCounter + "\n" + "Total minimum sums of squares: " + minimumSumOfSquares + "\n" + "Minimum Sums Of Squares At Internal Nodes: \n";
		while(minItr.hasNext())
		{
			tmpMini = (Map.Entry<String, Double>)minItr.next();
			result += tmpMini.getKey().toString() + ": " + tmpMini.getValue().toString() + "\n";
		}
		result += "\n" + "Permutation Indices At Internal Nodes: \n";
		result +="Node\t" + "Row\t" + "Column\n";
		while(permutationItr.hasNext())
		{
			tmpPermutation = (Map.Entry<String, ArrayList<Integer>>)permutationItr.next();
			tmpList = (ArrayList<Integer>)tmpPermutation.getValue();
			result += tmpPermutation.getKey().toString() + "\t" + (tmpList.get(0).intValue()+1) + "\t" + (tmpList.get(1).intValue()+1) + "\n";
		}
		result+="\n";
		result += "Best Fit joint probability matrices:\n ";
		
		while(bestFitJointProbMatricesItr.hasNext())
		{
			tmpBestFitJointProbMatrices = (Map.Entry<String, double[][]>)bestFitJointProbMatricesItr.next();
			tmpNodeName = tmpBestFitJointProbMatrices.getKey();
			tmpJointMatrix = tmpBestFitJointProbMatrices.getValue();
			result += "Node: " + tmpNodeName + "\n";
			
			for(j=0; j<4; j++)
			{
				for(k=0; k<4; k++)
				{
					result += tmpJointMatrix[j][k] + " ";
				}
				result += "\n";
			}
		}
		
		result+="\n";
		result += "Best Fit Marginal Frequencies:\n ";
		
		while(bestFitMarginalFrequenciesItr.hasNext())
		{
			tmpBestFitFrequencies = (Map.Entry<String, double[]>)bestFitMarginalFrequenciesItr.next();
			tmpNodeName = tmpBestFitFrequencies.getKey();
			tmpMarginalVector = tmpBestFitFrequencies.getValue();
			
			result += "Node: " + tmpNodeName + "\n";
			
			for(j=0; j<4; j++)
			{
				result += tmpMarginalVector[j] + " ";
			}
			
			result += "\n";
		}
		
		result += "\n";
		
		return result;
	}
}
