
public class containerNSGTRParameters 
{
	double[][] rateMatrix = null;
	double[] stationaryFrequencies = null;
	double stationaryEdgeLengths = 0.0;
	
	public containerNSGTRParameters() 
	{
		rateMatrix = new double[4][4];
		stationaryFrequencies = new double[4];
	}
	
	void setRateMatrix(double[][] inputCon)
	{
		int j=0, k=0; 
		
		for(j=0; j<4; j++)
		{
			for(k=0; k<4; k++)
			{
				rateMatrix[j][k] = inputCon[j][k];
			}
		}
	}
	
	void setStationaryFrequencies(double[] inputCon)
	{
		int j=0; 
		
		for(j=0; j<4; j++)
		{
			stationaryFrequencies[j] = inputCon[j];
		}

	}
	
	void setStationaryEdgeLength(double inputValue)
	{
		stationaryEdgeLengths = inputValue;
	}
	
	double[][] getRateMatrix()
	{
		return rateMatrix;
	}
	
	double[] getStationaryFrequencies()
	{
		return stationaryFrequencies;
	}
	
	double getStationaryEdgeLength()
	{
		return stationaryEdgeLengths;
	}
	
	public String toString()
	{
		String results = "";
		int j=0, k=0; 
		
		results += "Instantaneous Rate Matrix:\n"; 
		for(j=0; j<4; j++)
		{
			for(k=0; k<4; k++)
			{
				results += rateMatrix[j][k] + " ";
			}
			results += "\n";
		}
		
		results += "Stationary Frequencies:\n";
		for(j=0; j<4; j++)
		{
			results += stationaryFrequencies[j] + " ";
		}
		results += "\n";
		return results;
	}
}
